######################################################################
#
# 2004-11-01
# ==========
#
# mmmAdmin at idiap.ch
#
# Description: awk script that converts one *.txt file to *.xml
#
# Usage:
#
# awk -v outputTRSfile=output.trs -f  speakerSeg2XMLnew.awk  /path/file.txt
#
#
# Info: Do a "man awk" from your linux shell command.
#
######################################################################

BEGIN {
   RS = "\r*\n"
       FS = " "
       #filename = "/dev/null"
       chanNb = 0
       point="."
       endTimeString="endTime"
       cpt = 0
       filename = outputTRSfile
}

# line composed with one main string
#####################################
NF==1	{
	if ( $1 == point) {
		chanNb += 1
		next
	}
	else {
		if (chanNb == 0) {
			print "Generating " filename
			print "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>" >filename
			print "<!DOCTYPE Trans SYSTEM \"trans-13-icsi.dtd\">" >filename
			print "<Trans scribe=\"(unknown)\"  audio_filename=\"Mix-Headset\" version=\"1\" version_date=\"050101\">" >filename
			print "<Episode>" >filename
		}


	}
}


# line composed with 2 main strings (start and endTime)
########################################################
NF==2	{

                # case 2nd line: ending timestamp
		if ( ($1 == endTimeString) && ( cpt == 0) ) {
		
			print "<Section type =\"report\" startTime=\"0\" endTime=\"" $2 "\">" >filename
			print "<Turn startTime=\"0\" endTime=\"" $2 "\">" >filename
			print "<Sync chan=\"default\" time=\"0\"/>" >filename
			print "<Sync chan=\"0\" time=\"0\"/>" >filename
			cpt = cpt + 1

		}
		else {
		    if ( ($1 == endTimeString) && ( cpt > 0) ) {
			printf "<Sync chan=\"%d\" time=\"0\"/>\n", chanNb >filename
		    }
		    else {
			printf "<Sync chan=\"%d\" time=\"%.3f\" />\n", chanNb, $1 >filename
			printf "<Sync chan=\"%d\" time=\"%.3f\" />\n", chanNb, $2 >filename
			printf "..\n" >filename
		    }

		}
}


END {
	print "</Turn>" >filename
	print "</Section>" >filename
	print "</Episode>" >filename
	print "</Trans>" >filename
	#print "Warning: data had no end marker!"
}



